# TODO: use shared crates?
%define		crates_ver	0.26.0

Summary:	Tool for generating C bindings to Rust code
Summary(pl.UTF-8):	Narzędzie do generowania wiązań C do kodu w języku Rust
Name:		rust-cbindgen
Version:	0.26.0
Release:	1
License:	MPL v2.0
Group:		Development/Tools
#Source0Download: https://github.com/eqrion/cbindgen/releases
Source0:	https://github.com/eqrion/cbindgen/archive/v%{version}/cbindgen-%{version}.tar.gz
# Source0-md5:	f3ef70691bc4743b8f76ca6d27847ba4
# cd cbindgen-%{version}
# cargo vendor
# cd ..
# tar cJf cbindgen-crates-%{version}.tar.xz cbindgen-%{version}/{vendor,Cargo.lock}
Source1:	cbindgen-crates-%{crates_ver}.tar.xz
# Source1-md5:	deaba3b63f82630cae6953904e6a0a9e
URL:		https://github.com/eqrion/cbindgen
BuildRequires:	cargo
BuildRequires:	rpmbuild(macros) >= 2.004
BuildRequires:	rust
BuildRequires:	tar >= 1:1.22
BuildRequires:	xz
ExclusiveArch:	%{rust_arches}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
This project can be used to generate C bindings for Rust code.

%description -l pl.UTF-8
Ten projekt służy do generowania wiązań C do kodu w języku Rust.

%prep
%setup -q -n cbindgen-%{version} -a1

%{__mv} cbindgen-%{crates_ver}/* .
sed -i -e 's/@@VERSION@@/%{version}/' Cargo.lock

# use our offline registry
export CARGO_HOME="$(pwd)/.cargo"

mkdir -p "$CARGO_HOME"
cat >.cargo/config <<EOF
[source.crates-io]
registry = 'https://github.com/rust-lang/crates.io-index'
replace-with = 'vendored-sources'

[source.vendored-sources]
directory = '$PWD/vendor'
EOF

%build
export CARGO_HOME="$(pwd)/.cargo"

%cargo_build --frozen

%install
rm -rf $RPM_BUILD_ROOT
export CARGO_HOME="$(pwd)/.cargo"

%cargo_install --frozen --root $RPM_BUILD_ROOT%{_prefix} --path $PWD
%{__rm} $RPM_BUILD_ROOT%{_prefix}/.crates*

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc README.md CHANGES contributing.md docs.md internals.md
%attr(755,root,root) %{_bindir}/cbindgen
%changelog
* Thu Oct 26 2023 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/rust-cbindgen.git;a=log;h=master

* Tue Oct 24 2023 Jan Palus <atler@pld-linux.org> dc494c2
- up to 0.26.0

* Tue Jul 26 2022 Jan Palus <atler@pld-linux.org> cdfdca7
- up to 0.24.3

* Tue May 31 2022 Jan Palus <atler@pld-linux.org> d951c48
- up to 0.23.0

* Tue Jun 01 2021 Jan Palus <atler@pld-linux.org> e025a76
- use %cargo* macros

* Tue Jun 01 2021 Jan Palus <atler@pld-linux.org> a8163ed
- up to 0.19.0

* Tue Feb 23 2021 Jan Palus <atler@pld-linux.org> 0d88ec6
- BRs for tar.xz source

* Tue Feb 23 2021 Jan Palus <atler@pld-linux.org> a07cfd3
- up to 0.17.0

* Tue Nov 17 2020 Jan Palus <atler@pld-linux.org> bcd237b
- up to 0.15.0

* Tue Jul 28 2020 Jakub Bogusz <qboosh@pld-linux.org> 09150b2
- clean also .crates2.json

* Tue Jul 28 2020 Jan Palus <atler@pld-linux.org> 38c852b
- up to 0.14.3

* Tue Jun 02 2020 Jan Palus <atler@pld-linux.org> 8c2ba1b
- up to 0.14.2

* Sun May 03 2020 Jan Palus <atler@pld-linux.org> dbd044c
- add aarch64 to supported archs

* Wed Feb 12 2020 Jan Palus <atler@pld-linux.org> d3ec284
- up to 0.13.1

* Sun Sep 08 2019 Jan Rękorajski <baggins@pld-linux.org> 6acfceb
- up to 0.9.1

* Tue May 28 2019 Jakub Bogusz <qboosh@pld-linux.org> 0a17062
- release 2

* Sun May 26 2019 Jakub Bogusz <qboosh@pld-linux.org> 42fe2c0
- new

